#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct UpdateVideoMetadataRequest {
    #[builder(default, into)]
    #[serde(rename = "title", skip_serializing_if = "Option::is_none", default)]
    title: Option<String>,
    #[builder(default, into)]
    #[serde(rename = "description", skip_serializing_if = "Option::is_none", default)]
    description: Option<String>,
    #[builder(default, into)]
    #[serde(rename = "labels", skip_serializing_if = "Option::is_none", default)]
    labels: Option<std::collections::BTreeSet<String>>,
    #[builder(default, into)]
    #[serde(rename = "properties", skip_serializing_if = "Option::is_none", default)]
    properties: Option<std::collections::BTreeMap<String, String>>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::super::api::Timestamp>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(
        rename = "startingTimestamp",
        skip_serializing_if = "Option::is_none",
        default
    )]
    starting_timestamp: Option<Box<super::super::super::super::api::Timestamp>>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::ScaleParameter>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "scaleParameter", skip_serializing_if = "Option::is_none", default)]
    scale_parameter: Option<Box<super::ScaleParameter>>,
}
impl UpdateVideoMetadataRequest {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new() -> Self {
        Self::builder().build()
    }
    #[inline]
    pub fn title(&self) -> Option<&str> {
        self.title.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn description(&self) -> Option<&str> {
        self.description.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn labels(&self) -> Option<&std::collections::BTreeSet<String>> {
        self.labels.as_ref().map(|o| &*o)
    }
    #[inline]
    pub fn properties(&self) -> Option<&std::collections::BTreeMap<String, String>> {
        self.properties.as_ref().map(|o| &*o)
    }
    #[inline]
    pub fn starting_timestamp(
        &self,
    ) -> Option<&super::super::super::super::api::Timestamp> {
        self.starting_timestamp.as_ref().map(|o| &**o)
    }
    #[deprecated(
        note = "deprecated in favor of updating scaleParameter per-file. Will fail if set on a video with multiple files.\nWill be removed after April 15th.\n"
    )]
    #[inline]
    pub fn scale_parameter(&self) -> Option<&super::ScaleParameter> {
        self.scale_parameter.as_ref().map(|o| &**o)
    }
}
